// Autogenerated by convert_tests.py and process_polyglot.py.
// Do not edit this file directly.
// The template for this file is located at:
// ../../../../../../../templates/Test.java
package com.rethinkdb.gen;

import com.rethinkdb.RethinkDB;
import com.rethinkdb.gen.exc.*;
import com.rethinkdb.gen.ast.*;
import com.rethinkdb.ast.ReqlAst;
import com.rethinkdb.model.MapObject;
import com.rethinkdb.model.OptArgs;
import com.rethinkdb.net.Connection;
import com.rethinkdb.net.Cursor;
import junit.framework.TestCase;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertArrayEquals;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.junit.*;
import org.junit.rules.ExpectedException;

import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.time.OffsetDateTime;
import java.time.ZoneOffset;
import java.time.Instant;
import java.util.stream.LongStream;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import java.util.concurrent.TimeoutException;
import java.util.regex.Pattern;
import java.util.Collections;
import java.nio.charset.StandardCharsets;

import static com.rethinkdb.TestingCommon.*;
import com.rethinkdb.TestingFramework;

public class SindexNullsinstrings {
    // sindex nulls in strings
    Logger logger = LoggerFactory.getLogger(SindexNullsinstrings.class);
    public static final RethinkDB r = RethinkDB.r;
    public static final Table tbl = r.db("test").table("tbl");

    Connection conn;

    @Before
    public void setUp() throws Exception {
        logger.info("Setting up.");
        conn = TestingFramework.createConnection();
        try {
            r.dbCreate("test").run(conn);
            r.db("test").wait_().run(conn);
        }catch (Exception e){}
        try {
            r.db("test").tableCreate("tbl").run(conn);
            r.db("test").table(tbl).wait_().run(conn);
        }catch (Exception e){}
    }

    @After
    public void tearDown() throws Exception {
        logger.info("Tearing down.");
        r.db("rethinkdb").table("_debug_scratch").delete().run(conn);
        if(!conn.isOpen()){
            conn.close();
            conn = TestingFramework.createConnection();
        }
        r.db("test").tableDrop("tbl").run(conn);
        r.dbDrop("test").run(conn);
        conn.close(false);
    }

    // Autogenerated tests below

    @Test(timeout=120000)
    public void test() throws Exception {

        {
            // sindex/nullsinstrings.yaml line #4
            /* ({"created":1}) */
            Map expected_ = r.hashMap("created", 1L);
            /* tbl.index_create("key") */
            logger.info("About to run line #4: tbl.indexCreate('key')");
            Object obtained = runOrCatch(tbl.indexCreate("key"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #4");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #4:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // sindex/nullsinstrings.yaml line #6
            /* ([{"ready":true}]) */
            List expected_ = r.array(r.hashMap("ready", true));
            /* tbl.index_wait().pluck("ready") */
            logger.info("About to run line #6: tbl.indexWait().pluck('ready')");
            Object obtained = runOrCatch(tbl.indexWait().pluck("ready"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #6");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #6:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // sindex/nullsinstrings.yaml line #10
            /* ({"inserted":2}) */
            Map expected_ = r.hashMap("inserted", 2L);
            /* tbl.insert([{"id":1,"key":["a","b"]},{"id":2,"key":["a\u0000Sb"]}]).pluck("inserted") */
            logger.info("About to run line #10: tbl.insert(r.array(r.hashMap('id', 1L).with('key', r.array('a', 'b')), r.hashMap('id', 2L).with('key', r.array('a\\u0000Sb')))).pluck('inserted')");
            Object obtained = runOrCatch(tbl.insert(r.array(r.hashMap("id", 1L).with("key", r.array("a", "b")), r.hashMap("id", 2L).with("key", r.array("a\u0000Sb")))).pluck("inserted"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #10");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #10:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // sindex/nullsinstrings.yaml line #13
            /* ([{"id":2}]) */
            List expected_ = r.array(r.hashMap("id", 2L));
            /* tbl.get_all(["a\u0000Sb"], index="key").pluck("id") */
            logger.info("About to run line #13: tbl.getAll(r.array('a\\u0000Sb')).optArg('index', 'key').pluck('id')");
            Object obtained = runOrCatch(tbl.getAll(r.array("a\u0000Sb")).optArg("index", "key").pluck("id"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #13");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #13:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }

        {
            // sindex/nullsinstrings.yaml line #18
            /* ([{"id":1}]) */
            List expected_ = r.array(r.hashMap("id", 1L));
            /* tbl.get_all(["a","b"], index="key").pluck("id") */
            logger.info("About to run line #18: tbl.getAll(r.array('a', 'b')).optArg('index', 'key').pluck('id')");
            Object obtained = runOrCatch(tbl.getAll(r.array("a", "b")).optArg("index", "key").pluck("id"),
                                          new OptArgs()
                                          ,conn);
            try {
                assertEquals(expected_, obtained);
            logger.info("Finished running line #18");
            } catch (Throwable ae) {
                logger.error("Whoops, got exception on line #18:" + ae.toString());
                if(obtained instanceof Throwable) {
                    ae.addSuppressed((Throwable) obtained);
                }
                throw ae;
            }
        }
    }
}
